using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Configuration;

namespace MySecondApp
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button buttonOK;
		private System.Windows.Forms.Button buttonCancel;
		private System.Windows.Forms.Button buttonOptions;
        private IContainer components;
		private MyFirstControlLibrary.FullAddress fullAddress1;
        private ToolTip toolTipHelp;
        private Label labelHelp;
        private ErrorProvider errorProviderMain;
        private MyFirstControlLibrary.Banner banner1;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
               
            //appSettings are obsolete, use applicationSettings
            //AppSettingsReader appSettings = new AppSettingsReader();
            //object o = appSettings.GetValue("MainFormOpacity", typeof(double));
            //this.Opacity = (double) o;

            this.Opacity = Properties.Settings.Default.Opacity;
                //Convert.ToDouble(System.Configuration.ConfigurationSettings.AppSettings.Get("MainFormOpacity"));

			//this.BackgroundImage = new Bitmap(@"C:\WINDOWS\Web\Wallpaper\Autumn.jpg");
			//this.BackgroundImage = new Bitmap(GetType(), "Crystal.jpg");
            this.BackgroundImage = Properties.Resources.Crystal;

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
            System.Configuration.AppSettingsReader configurationAppSettings = new System.Configuration.AppSettingsReader();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.textBox2 = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.buttonOK = new System.Windows.Forms.Button();
            this.buttonCancel = new System.Windows.Forms.Button();
            this.buttonOptions = new System.Windows.Forms.Button();
            this.banner1 = new MyFirstControlLibrary.Banner();
            this.fullAddress1 = new MyFirstControlLibrary.FullAddress();
            this.toolTipHelp = new System.Windows.Forms.ToolTip(this.components);
            this.labelHelp = new System.Windows.Forms.Label();
            this.errorProviderMain = new System.Windows.Forms.ErrorProvider(this.components);
            ((System.ComponentModel.ISupportInitialize)(this.errorProviderMain)).BeginInit();
            this.SuspendLayout();
            // 
            // textBox1
            // 
            this.textBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.textBox1.Location = new System.Drawing.Point(120, 80);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new System.Drawing.Size(184, 20);
            this.textBox1.TabIndex = 0;
            this.textBox1.Text = "Joe";
            this.toolTipHelp.SetToolTip(this.textBox1, "Anchor Left, Top, Right\r\nValidate that name is not empty");
            this.textBox1.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.textBox1.Validating += new System.ComponentModel.CancelEventHandler(this.textBox1_Validating);
            this.textBox1.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // textBox2
            // 
            this.textBox2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.textBox2.Location = new System.Drawing.Point(120, 120);
            this.textBox2.Name = "textBox2";
            this.textBox2.Size = new System.Drawing.Size(184, 20);
            this.textBox2.TabIndex = 1;
            this.textBox2.Text = "Reader";
            this.toolTipHelp.SetToolTip(this.textBox2, "Anchor Left, Top, Right");
            this.textBox2.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.textBox2.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(40, 80);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(72, 23);
            this.label1.TabIndex = 2;
            this.label1.Text = "First Name";
            this.toolTipHelp.SetToolTip(this.label1, "Anchor Left, Top, Right\r\nUse ambient background color (default)");
            this.label1.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.label1.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(40, 120);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(72, 23);
            this.label2.TabIndex = 3;
            this.label2.Text = "Last Name";
            this.toolTipHelp.SetToolTip(this.label2, "Anchor Left, Top, Right\r\nUse ambient background color (default)");
            this.label2.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.label2.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // buttonOK
            // 
            this.buttonOK.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.buttonOK.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.buttonOK.Location = new System.Drawing.Point(55, 436);
            this.buttonOK.Name = "buttonOK";
            this.buttonOK.Size = new System.Drawing.Size(75, 23);
            this.buttonOK.TabIndex = 4;
            this.buttonOK.Text = "OK";
            this.toolTipHelp.SetToolTip(this.buttonOK, "Anchor Bottom\r\nUse ambient background color (default)\r\nMessageBox on close");
            this.buttonOK.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.buttonOK.Click += new System.EventHandler(this.buttonOK_Click);
            this.buttonOK.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // buttonCancel
            // 
            this.buttonCancel.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.buttonCancel.CausesValidation = false;
            this.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.buttonCancel.Location = new System.Drawing.Point(140, 436);
            this.buttonCancel.Name = "buttonCancel";
            this.buttonCancel.Size = new System.Drawing.Size(75, 23);
            this.buttonCancel.TabIndex = 5;
            this.buttonCancel.Text = "Cancel";
            this.toolTipHelp.SetToolTip(this.buttonCancel, "Anchor Bottom\r\nUse ambient background color (default)\r\nConfirms that form should " +
                    "be closed.\r\nCausesValidation is false, all other controls have it as true");
            this.buttonCancel.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.buttonCancel.Click += new System.EventHandler(this.buttonCancel_Click);
            this.buttonCancel.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // buttonOptions
            // 
            this.buttonOptions.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.buttonOptions.BackColor = global::MySecondApp.Properties.Settings.Default.Color;
            this.buttonOptions.Location = new System.Drawing.Point(221, 436);
            this.buttonOptions.Name = "buttonOptions";
            this.buttonOptions.Size = new System.Drawing.Size(75, 23);
            this.buttonOptions.TabIndex = 9;
            this.buttonOptions.Text = "Options";
            this.toolTipHelp.SetToolTip(this.buttonOptions, resources.GetString("buttonOptions.ToolTip"));
            this.buttonOptions.UseVisualStyleBackColor = false;
            this.buttonOptions.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.buttonOptions.Click += new System.EventHandler(this.buttonOptions_Click);
            this.buttonOptions.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // banner1
            // 
            this.banner1.Anchor = System.Windows.Forms.AnchorStyles.Top;
            this.banner1.BackColor = System.Drawing.Color.Transparent;
            this.banner1.Location = new System.Drawing.Point(32, 16);
            this.banner1.Name = "banner1";
            this.banner1.Size = new System.Drawing.Size(288, 48);
            this.banner1.TabIndex = 10;
            this.toolTipHelp.SetToolTip(this.banner1, "Anchor Top\r\nBackColor set to transparent, so background image of parent is visibl" +
                    "e\r\nUser control from the control library\r\n");
            this.banner1.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.banner1.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // fullAddress1
            // 
            this.fullAddress1.Anchor = System.Windows.Forms.AnchorStyles.Top;
            this.fullAddress1.Location = new System.Drawing.Point(56, 160);
            this.fullAddress1.Name = "fullAddress1";
            this.fullAddress1.Size = new System.Drawing.Size(240, 96);
            this.fullAddress1.TabIndex = 0;
            this.toolTipHelp.SetToolTip(this.fullAddress1, "Anchor Top\r\nUser control from the control library");
            this.fullAddress1.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.fullAddress1.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // labelHelp
            // 
            this.labelHelp.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Left | System.Windows.Forms.AnchorStyles.Right)));
            this.labelHelp.Location = new System.Drawing.Point(56, 289);
            this.labelHelp.Name = "labelHelp";
            this.labelHelp.Size = new System.Drawing.Size(240, 126);
            this.labelHelp.TabIndex = 11;
            this.toolTipHelp.SetToolTip(this.labelHelp, "Anchor Left,Right\r\nUse ambient background color (default)");
            this.labelHelp.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.labelHelp.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // errorProviderMain
            // 
            this.errorProviderMain.ContainerControl = this;
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.SystemColors.Control;
            this.BackgroundImage = global::MySecondApp.Properties.Resources.Ascent;
            this.ClientSize = new System.Drawing.Size(344, 490);
            this.Controls.Add(this.labelHelp);
            this.Controls.Add(this.banner1);
            this.Controls.Add(this.fullAddress1);
            this.Controls.Add(this.buttonOptions);
            this.Controls.Add(this.buttonCancel);
            this.Controls.Add(this.buttonOK);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.textBox2);
            this.Controls.Add(this.textBox1);
            this.DataBindings.Add(new System.Windows.Forms.Binding("Location", global::MySecondApp.Properties.Settings.Default, "DefLoc", true, System.Windows.Forms.DataSourceUpdateMode.OnPropertyChanged));
            this.Location = global::MySecondApp.Properties.Settings.Default.DefLoc;
            this.Name = "MainForm";
            this.Text = ((string)(configurationAppSettings.GetValue("Form1.Text", typeof(string))));
            this.toolTipHelp.SetToolTip(this, resources.GetString("$this.ToolTip"));
            this.Load += new System.EventHandler(this.Form1_Load);
            this.Paint += new System.Windows.Forms.PaintEventHandler(this.MainForm_Paint);
            this.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            this.Closing += new System.ComponentModel.CancelEventHandler(this.MainForm_Closing);
            this.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            ((System.ComponentModel.ISupportInitialize)(this.errorProviderMain)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
		
		}

		private void banner1_Load(object sender, System.EventArgs e)
		{
		
		}

		private void buttonOptions_Click(object sender, System.EventArgs e)
		{
			Options dlg = new Options();
			dlg.FavoriteColor = this.BackColor;
			if (dlg.ShowDialog() == DialogResult.OK) 
			{
				this.BackColor = dlg.FavoriteColor;
				
			}
		}

		private void buttonCancel_Click(object sender, System.EventArgs e)
		{
			if (DialogResult.Yes == MessageBox.Show("You have cancelled this operation. Your personal information will be discarded.",
				"Are You Sure???", MessageBoxButtons.YesNo)) 
			{
				this.Close();
			}
			
		}

		private void buttonOK_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show("We have not learned how to save your data, so your personal information has been discarded.");
			this.Close();
		}

		private void MainForm_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
		}

		private void textBox1_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			errorProviderMain.SetError(textBox1, "");
			if (textBox1.Text == "") 
			{
				errorProviderMain.SetError(textBox1, "First name cannot be empty");
				e.Cancel = true;
			}
		}

		private void MainForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			e.Cancel = false;
		}

        private void Generic_MouseEnter(object sender, EventArgs e)
        {
            labelHelp.Text = toolTipHelp.GetToolTip(((Control)sender));
            toolTipHelp.SetToolTip(((Control)sender), "");
        }

        private void Generic_MouseLeave(object sender, EventArgs e)
        {
            toolTipHelp.SetToolTip(((Control)sender), labelHelp.Text);
            labelHelp.Text = "";            
        }
	}
}
